#ifndef R8LP_H
#define R8LP_H

#include <stdint.h>

#include "mem.h"
#include "pft.h"
#include "rklp.h"

#define R8LP_K 8

typedef struct r8lp_struct
{
    // Per-group state bits
    volatile unsigned int S;
    unsigned int _buf1[15];

    // Eight different reader phases
    rklp_group_t groups[R8LP_K];

    // Potentially cache lock state to handle race condition on unlock
    rklp_cached_state_t cached_state[R8LP_K];

} __attribute ((aligned (64) )) r8lp_t;

void r8lp_init(r8lp_t *lock);

uint64_t *r8lp_lock(r8lp_t *lock, unsigned int groupnum);
uint64_t *r8lp_unlock(r8lp_t *lock, unsigned int groupnum);

#endif // R8LP_H
