#!/bin/bash

edir="experiments"
m=16
protocols="NOLOCK UCRNLP GCRNLP CGLP"
outcsv="out.csv"
csvdir="csvs"
plotdir="plots"
tdir=$(date +"%m_%d_%Y-%H:%M")
outfile="params.txt"
datagenfile="datagen.py"

echo "Making a new folder in" $edir
mkdir $edir/$tdir

echo "Saving experiment params to" $outfile
grep 'MIN_SAMPLES =' datagen.py >> $edir/$tdir/$outfile
grep 'MIN_SAMPLES=' datagen.py >> $edir/$tdir/$outfile
grep 'MAX_SAMPLES =' datagen.py >> $edir/$tdir/$outfile
grep 'MAX_SAMPLES=' datagen.py >> $edir/$tdir/$outfile
grep 'convert_func = m' datagen.py >> $edir/$tdir/$outfile
grep 'params' datagen.py >> $edir/$tdir/$outfile
sed 's/#.*$//' < $edir/$tdir/$outfile > $edir/$tdir/temp.txt
mv $edir/$tdir/temp.txt $edir/$tdir/$outfile

echo "Saving datagen.py to" $datagenfile
cp datagen.py $edir/$tdir/$datagenfile

echo "Running an example set of experiments"
python datagen.py -o $edir/$tdir/$outcsv -m $m 

echo "Making directory for csvs"
mkdir $edir/$tdir/$csvdir

echo "Splitting csv and placing resulting csvs in new directory"
python $edir/csv2csvs.py $edir/$tdir/$outcsv -o $edir/$tdir/$csvdir -i sys_util $protocols

echo "Generating plot for each new csv"
python $edir/plotter.py $edir/$tdir/$csvdir/*

echo "Making directory for plots"
mkdir $edir/$tdir/$plotdir

echo "Moving plots to plot dir"
mv $edir/$tdir/$csvdir/*png $edir/$tdir/$plotdir
mv $edir/$tdir/$csvdir/*pdf $edir/$tdir/$plotdir
